#! /usr/bin/awk -f
# made test for Gaussianity using Kullback divergence
# in unidirectional NE experiments
# see https://doi.org/10.1063/1.5120616 for details
#
BEGIN{
beta=1.0/0.596128; 
kcal =1./4.184; wmin = 1E20
}
{
    wt=kcal*$1; wtj[NR]=wt; 
    w+=wt; w2+=wt^2; w3+=wt^3; w4+=wt^4;
    if(wt < wmin) {wmin=wt}
} 
END {
    wm= w/NR; w2m=w2/NR; w3m=w3/NR; w4m=w4/NR; 
    sig= w2m-wm^2;
    dg=wm-0.5*beta*sig
    err=1.96*(sqrt(sig/NR) + 0.5*beta*sqrt(2./NR)*sig)
    norm=1./(2*3.14159265359*sig)^0.5
    wdiss=beta*sig
    wmin=wm-2*wdiss
    wmax=wm+wdiss
    dw=(wmax-wmin)/1000
    w=wmin-dw
    kl=0.0
    for(i=1;i<=1000;i++){
	w=w+dw
	p1=norm*exp(-(w-wm)^2/(2*sig)) 
	q1=norm*exp(-(w-wm+wdiss)^2/(2*sig))
	kl+=p1*log(p1/q1)*dw
#	print w, p1,q1,kl
    }
    dgk=wm-kl
    print "#", dgk,"0",dg,err
}
